zoukankan      html  css  js  c++  java
  • One Person Game ZOJ Problem Set 3329

    One Person Game

    Time Limit: 1 Second      Memory Limit: 32768 KB      Special Judge

    There is a very simple and interesting one-person game. You have 3 dice, namely Die1, Die2 and Die3. Die1 has K1 faces. Die2 has K2 faces. Die3 has K3 faces. All the dice are fair dice, so the probability of rolling each value, 1 to K1, K2, K3 is exactly 1 / K1, 1 / K2 and 1 / K3. You have a counter, and the game is played as follow:

    1. Set the counter to 0 at first.
    2. Roll the 3 dice simultaneously. If the up-facing number of Die1 is a, the up-facing number of Die2 is b and the up-facing number of Die3 is c, set the counter to 0. Otherwise, add the counter by the total value of the 3 up-facing numbers.
    3. If the counter's number is still not greater than n, go to step 2. Otherwise the game is ended.

    Calculate the expectation of the number of times that you cast dice before the end of the game.

    Input

    There are multiple test cases. The first line of input is an integer T (0 < T <= 300) indicating the number of test cases. Then T test cases follow. Each test case is a line contains 7 non-negative integers n, K1, K2, K3, a, b, c (0 <= n <= 500, 1 < K1, K2, K3 <= 6, 1 <= a <= K1, 1 <= b <= K2, 1 <= c <= K3).

    Output

    For each test case, output the answer in a single line. A relative error of 1e-8 will be accepted.

    Sample Input

    2
    0 2 2 2 1 1 1
    0 6 6 6 1 1 1
    

    Sample Output

    1.142857142857143
    1.004651162790698
    

    Author: CAO, Peng
    Source: The 7th Zhejiang Provincial Collegiate Programming Contest

    dp求期望的题。
        题意:
        有三个均匀的骰子,分别有k1,k2,k3个面,初始分数是0,
        当掷三个骰子的点数分别为a,b,c的时候,分数清零,否则分数加上三个骰子的点数和,
        当分数>n的时候结束。求需要掷骰子的次数的期望。
        题解:
        设 E[i]表示现在分数为i,到结束游戏所要掷骰子的次数的期望值。
        显然 E[>n] = 0; E[0]即为所求答案;
        E[i] = ∑Pk*E[i+k] + P0*E[0] + 1; (Pk表示点数和为k的概率,P0表示分数清零的概率)
        由上式发现每个 E[i]都包含 E[0],而 E[0]又是我们要求的,是个定值。
        设 E[i] = a[i]*E[0] + b[i];
        将其带入上面的式子:
        E[i] = ( ∑Pk*a[i+k] + P0 )*E[0] + ∑Pk*b[i+k] + 1;
        显然,
        a[i] = ∑Pk*a[i+k] + P0;
        b[i] = ∑Pk*b[i+k] + 1;
        当 i > n 时:
        E[i] = a[i]*E[0] + b[i] = 0;
        所以 a[i>n] = b[i>n] = 0;
        可依次算出 a[n],b[n]; a[n-1],b[n-1] ... a[0],b[0];
        则 E[0] = b[0]/(1 - a[0]);

    #include <cstdio>
    #include <cstring>
    #include <iostream>
    
    using namespace std;
    
    int main()
    {
        int    nc, n, ks, k1, k2, k3, a, b, c;
        double p0, p[20];
    
        cin >> nc;
        while ( nc-- )
        {
            cin >> n >> k1 >> k2 >> k3 >> a >> b >> c;
            ks = k1 + k2 + k3;
            p0 = 1.0 / (k1*k2*k3);
            memset(p, 0, sizeof(p));
    
            for (int i = 1; i <= k1; i++)
                for (int j = 1; j <= k2; j++)
                    for (int k = 1; k <= k3; k++)
                    {
                        if ( i != a || j != b || k != c )
                            p[i+j+k] += p0;
                    }
    
            double a[520] = {0}, b[520] = {0};
            for (int i = n; i >= 0; i--)
            {
                for (int k = 3; k <= ks; k++)
                {
                    a[i] += a[i+k]*p[k];
                    b[i] += b[i+k]*p[k];
                }
                a[i] += p0;
                b[i] += 1;
            }
            printf("%.15lf\n", b[0]/(1 - a[0]) );
        }
        return 0;
    }
    

      

  • 相关阅读:
    HTML页面下echarts图形绘制
    nth-child的运用
    黑客零做起
    回溯法-背包问题
    回溯法-迷宫问题
    ECMA概述
    微信小程序-蓝牙
    JavaScript实现千位分隔符
    Vue 就地复用策略
    内联函数inline
  • 原文地址:https://www.cnblogs.com/huicpc0212/p/3038133.html
Copyright © 2011-2022 走看看